import { defineStore } from "pinia";

export const RouterTagData = defineStore({
  id: "RouterTagData",
  state: () => ({
    tagData: [] || localStorage.getItem("RouterTagData"),
    getMenuTabSate: localStorage.getItem("menuTabSate") || "",
  }),
  getters: {},
  actions: {
    tagsPushData(data) {
      // 先将已有的相同 name 的标签移除
      this.tagData = this.tagData.filter((res) => res.name !== data.name);
      // 再将新的标签加入
      this.tagData.push(data);
      this.localStorageTagsData(this.tagData);
      this.getDefault(data.name);
    },
    // 初始化标签
    tagsPushFilter(data) {
      if (data.length !== 0) {
        this.tagData = JSON.parse(data);
      } else {
        this.tagData = data;
      }
    },
    // 删除标签
    handleRemove(data) {
      this.tagData.forEach((item, index) => {
        if (item.name === data) {
          const itemIndex = index;
          let previousItem = null;
          // 判断是否是最后一个元素
          if (itemIndex === this.tagData.length - 1) {
            if (itemIndex > 0) {
              previousItem = this.tagData[itemIndex - 1];
            }
          } else {
            previousItem = this.tagData[itemIndex + 1];
          }
          this.tagData.splice(index, 1);
          this.localStorageTagsData(this.tagData);
          // 添加判断，避免previousItem为null时报错（比如删除最后一个元素且之前判断没取到前一个元素时）
          if (previousItem) {
            this.getDefault(previousItem.name);
          }
        }
      });
    },
    localStorageTagsData(data) {
      localStorage.setItem("RouterTagData", JSON.stringify(data));
    },
    // 默认选中菜单
    getDefault(data) {
      this.getMenuTabSate = data;
      localStorage.setItem("menuTabSate", data);
    },
  },
});
